/**
 * 
 * UPDATE BY FT: 25.04.17 (15:00)
 * 
 * 
* Name: Li-BIM
* Author: Mog et Alice et Patrick
* Description: 
* Tags: 
*/

model OccLiBIM
import "Core_Li_BIM_2017.gaml"


// BEGINNING OF THE AGENT WORLD ***************************************************************************



//*************************** BEGINNING OF THE AGENT OCCUPANT ******************************
species occupant control: simple_bdi {
	//Description
	int gender; //1:woman, 2:man
	int adult_child; //1:child, 2:adult
	int wealth; //1:poor ->3:super rich
	int green_conscious;  //0: Unaware -> 2:Concerned
	int building_knowledge; //0:no knowledge -> 2:advanced knowledge
	int individualism; //0:collectif -> 1:individualist
	int Profile;
	bool job <- true; //vrai si bosse, faux pour chomeur, retraité, etc.
	list<occupant> my_family;  // autres occupant habitant le foyer
	bool smoker;
	bool is_sleeping <- false;
	bool at_home <- true;
	list<occupant> people_to_discuss;  // autres occupant habitant le foyer
	int number;
	float thermal_effort;  // écart de température toléré (dans le froid)  par les personnes ayant une propention à l'écologie 
	float my_perceive_delta_temp;
	
	//Graphical representation 
	rgb mycolor;
	float mysize;
	string my_file;
	pair init_rotation;
	float translation;

	//Parameters
	float ideal_hour_to_sleep <- 23.0;
	float ideal_hour_for_diner <- 20.0;
	float ideal_hour_for_lunch <- 13.0;
	float ideal_hour_for_breakfast <- 8.0; // Ideal time to breakfast
	float leave_home_to_job <- 8.0;
	float return_home_after_job <- 18.0;
    float delta_temp_cold; //Tolerance on this ideal temperature froid
    float sensitive_to_cold; // I am more or less sensitive to cold temperature
    float delta_temp_warm; //Tolerance on this ideal temperature chaud
    float sensitive_to_warm; // I am more or less sensitive to warm temperature
    float ideal_temp<-20.0; // the average ideal temperaturefor me
	room my_bedroom; //The bedroom where he uses to sleep
	
		
	//Variables à chaque pas de temps (en fonction de la température et de sa localisation	
	room my_location;
	room my_previous_location;
	float my_temp_low;
	float my_temp_up;
	float temp_ope; //change en fonction de l'habillement et de l'activité (!!!)
	float clothing<-0.69 update:((current_date.month>=5) and (current_date.month<=9))? 0.5:0.69; // change en fonction de l'inconfort thermique et de la saison
	bool sweater<-true;
	
	
	//Status bar;
	float my_energy; //from 0:completly exhausted to 1:well-rested
	float my_fullness; //from 0:starving  to 1:full
	float my_cleanliness; //from 0:my_cleanliness to 1:clean
	float my_need_to_toilet; //from 0:very urgent to 1:perfect
	float my_comfort; //from 0:very disconmfort to 1:perfect my_comfort
	float avg_comfort;
	float my_will_to_wash_clothes; //from 0:no more clean clothes to 1:washmachine have been done
	float my_need_to_smoke; //from 0:really need to smoke to 1:occupant has smoken
	float my_need_of_fresh_air; //from 0:really need to get fresh air outside to 1:occupant wants to be at home
	float house_cleanliness; //from 0:the house is dirty to 1:the house is clean
	
	// How long does it take for the status bar to get empty (time before next)
	float h_hungryness;
	float h_tiredness;
	float h_dirtyness;  //self washing
	float h_need_to_toilet;
	float h_lack_smoking;
	float h_dirty_clothes;
	float h_dirty_house;
	float h_need_fresh_air;
	
	// How long does it take for the status bar to get plenty (time of the action)
	float h_eat;
	float h_sleep;
	float h_cook;
	float h_shower;
	float h_poop;
	float h_smoke;
	float h_wash_clothes;
	float h_take_fresh_air;
	float h_clean_house;

	//Priority on the predicates
	int P_work;
	int P_eat;
	int P_sleep;
	int P_relax;
	int P_go_to_wc;
	int P_take_a_shower;
	int P_mod_temp;
	int P_smoke;
	int P_wash_clothes;
	int P_go_out;
	int P_clean_house;
	
	//Default value for the priority
	int Def_P_work <- 10;
	int Def_P_eat <- 5;
	int Def_P_sleep <- 9;
	int Def_P_relax <- 1;
	int Def_P_go_to_wc <- 6;
	int Def_P_take_a_shower <- 4;
	int Def_P_mod_temp<-5;
	int Def_P_smoke <-7;
	int Def_P_wash_clothes <-2;
	int Def_P_go_out<-8;
	int Def_P_clean_house <-3;
	
	//Activity 0:sleep, 1:relax, 2:shower, 3:wc,  4:eat, 5:cook, 6:work, 7:smoke, 8:wash cloth, 9:go out, 10:clean house, 11:discuss comfort, 12:discuss GO, 13: modify temp
	int activity<-1; 
	int my_previous_activity<-1;
	int P_occ;
	list<int> cycle_activity<-[0,0,0,0,0,0,0,0,0,0,0,0,0,0];
	rgb my_activity_color <- # black; 
	
	//State variable
	bool cook_ok<-false;
	float progress<-0.0;
	bool sleeping_time<-false;
	bool breakfast_time<-false;
	bool lunch_time<-false;
	bool diner_time<-false;
	date last_temp_modif;
	date last_temp_modif_clo;
	float delta_date_temp_modif;
	float delta_date_cloth_modif<-20 #mn;
	
	
	 //fonction qui me donne les liens sociaux
 	list<float> social(occupant occ) {
 	float dom;
 	float sol;
 	float fam;
 	float lik;
 	dom<-get_dominance(get_social_link(new_social_link(occ)));
 	sol<-get_solidarity(get_social_link(new_social_link(occ)));
 	fam<-get_familiarity(get_social_link(new_social_link(occ)));
 	lik<-get_liking(get_social_link(new_social_link(occ)));
 	return [dom,sol, fam, lik];  //vecteur : 0: dominance, 1: solidarité, 2: familiarité, 3 : appréciation
 }
	
	//Beginning of the predicates --------------------------------------------------------------------------------
//predicate 'Belief'
	predicate is_hungry <- new_predicate("is_hungry");
	predicate starving <- new_predicate("starving");
	predicate is_tired <- new_predicate("is_tired");
	predicate is_exhausted <- new_predicate("is_exhausted");
	predicate must_work <- new_predicate("must_work");
	predicate need_wc <- new_predicate("need_wc");
	predicate feel_my_cleanliness <- new_predicate("feel_my_cleanliness");	
	predicate feel_unconfort <- new_predicate("feel_unconfort");
	predicate need_cigarette <- new_predicate("need_cigarette");
	predicate need_laundry <- new_predicate("need_laundry");
	predicate need_go_out <-  new_predicate("need_go_out");
	predicate need_clean_house <- new_predicate("need_clean_house");
	predicate need_to_discuss_co<- new_predicate("need_to_discuss_co");
	predicate need_to_discuss_go<- new_predicate("need_to_discuss_go");
		
//predicate 'Desire'
	 predicate work <- new_predicate("work") with_priority P_work update: work with_priority P_work;
	 predicate eat <- new_predicate("eat") with_priority P_eat update: eat with_priority P_eat;
	 predicate cook <- new_predicate("cook") with_priority P_eat update: eat with_priority P_eat;
 	 predicate sleep <- new_predicate("sleep") with_priority P_sleep update: sleep with_priority P_sleep;
	 predicate relax <- new_predicate("relax") with_priority P_relax update: relax with_priority P_relax;
	 predicate go_to_wc <- new_predicate("go_to_wc") with_priority P_go_to_wc update:go_to_wc with_priority P_go_to_wc;
	 predicate take_a_shower <- new_predicate("take_a_shower") with_priority P_take_a_shower update:take_a_shower with_priority P_take_a_shower;
	 predicate mod_temp <- new_predicate("mod_temp") with_priority P_mod_temp update:mod_temp with_priority P_mod_temp;
  	 predicate smoke <- new_predicate("smoke") with_priority P_smoke update: smoke with_priority P_smoke;
  	 predicate wash_clothes <- new_predicate("wash_clothes") with_priority P_wash_clothes update: wash_clothes with_priority P_wash_clothes;
	 predicate go_out <- new_predicate("go_out") with_priority P_go_out update: go_out with_priority P_go_out;
 	 predicate clean_house <- new_predicate("clean_house") with_priority P_clean_house update: clean_house with_priority P_clean_house;
	 predicate discuss_co<- new_predicate("discuss_co") with_priority 99;
	 predicate discuss_go<- new_predicate("discuss_go") with_priority 100;
	 
//Beginning of the perception of the agent from himself and his environment  --------------------------
	perceive target: self	{
	do clear_intentions; //remove prvious intention
		my_location <- room closest_to self;
		ask building{myself.temp_ope <- temp_int+abs(myself.clothing-1)*6;}

	
	//vidage des différentes barres
	self.my_will_to_wash_clothes <- max ([0.0, my_will_to_wash_clothes - step/h_dirty_clothes]); //la propreté des vêtements dépend seulement des jours passés depuis la dernière machine à laver
	self.my_need_of_fresh_air <- max ([0.0, my_need_of_fresh_air - step/h_need_fresh_air]) ;
	self.house_cleanliness <- max ([0.0, house_cleanliness - step/h_dirty_house]) ;   
	
	if get_current_intention() != sleep		{
		self.my_energy <- max([0.0, my_energy - step / h_tiredness]);
		self.my_fullness <- max([0.0, my_fullness - step / h_hungryness]);
		self.my_cleanliness <- max([0.0, my_cleanliness - step / h_dirtyness]);
		if self.smoker {self.my_need_to_smoke <- max([0.0, my_need_to_smoke - step/h_lack_smoking]);} //s'il est fumeur, son envie de fumer va augmenter lorsqu'il n'est pas entrain de dormir
	}
	else {
		self.my_fullness <- max([0.0, my_fullness - step / h_hungryness / 3]); //quand on dort, la faim augmente qd même, mais plus lentement ( /3) 
	}
	if (get_current_intention() != work) {self.my_need_to_toilet <- max([0.0, my_need_to_toilet - step / h_need_to_toilet]);	}
	

//Estimation of his needs and state
//Estimation of his tiredness
		if (my_energy < 0.5) {do add_belief(is_tired);}
		if (my_energy = 0) {do add_belief(is_exhausted);}
		if (current_date.hour >= ideal_hour_to_sleep)  	{self.sleeping_time<-true;}
		else  {self.sleeping_time<-false;}     //he estimates whether  time is appropriate to go sleeping
			
//Estimation of his my_fullness
		if (my_fullness < 0.5) 	{do add_belief(is_hungry);}
		if (my_fullness = 0) 		{do add_belief(starving);}
		self.lunch_time<-false;
		self.diner_time<-false;
		self.breakfast_time<-false;
		if(current_date.hour >= ideal_hour_for_diner - 1 and current_date.hour <= ideal_hour_for_diner + 1) {self.diner_time<-true;} //he evaluates wheter time is appropriate to eat
		if(current_date.hour >= ideal_hour_for_breakfast - 1 and current_date.hour <= ideal_hour_for_breakfast + 1)	{self.breakfast_time<-true;}
		if(current_date.hour >= ideal_hour_for_lunch - 1 and current_date.hour <= ideal_hour_for_lunch + 1)	{self.lunch_time<-true;}

//Estimation of his dirtiness
		if (my_cleanliness = 0) {do add_belief(feel_my_cleanliness);	}

//Estimation of the dirtiness of his clothes
		if (my_will_to_wash_clothes =0 and h_dirty_clothes>0) {do add_belief(need_laundry);}
		
//Estimation if he should clean the house
		if(at_home and h_clean_house>0 and house_cleanliness=0){do add_belief(need_clean_house);}
	

//Estimation of his desire of smoking
		if smoker {if (my_need_to_smoke =0) {do add_belief(need_cigarette);}}

//Estimation of his need to go to my_need_to_toilets
		if (my_need_to_toilet = 0)		{do add_belief(need_wc);}
		
//Estimation of his my_comfort
		myself.my_temp_up<-myself.my_location.temperature_upper ;
		myself.my_temp_low<-myself.my_location.temperature_lower ;
		
		ask building {
		myself.my_perceive_delta_temp<-myself.ideal_temp-temp_int;
			if ((temp_int<(myself.my_temp_low-myself.delta_temp_cold)) or (temp_int>(myself.my_temp_up+myself.delta_temp_warm))) {	
				myself.my_comfort<-0.0;
				
			}
			if ((temp_int>myself.my_temp_low) and (temp_int<myself.my_temp_up)) {	
				myself.my_comfort<-1.0;
			}	
			if ((temp_int>(myself.my_temp_low-myself.delta_temp_cold))and (temp_int<myself.my_temp_low)) {	
				myself.my_comfort<-max([0,1+(temp_int-myself.my_temp_low)/myself.delta_temp_cold]);
			}
			if ((temp_int<(myself.my_temp_up+myself.delta_temp_warm)) and (temp_int>myself.my_temp_up))	{
				myself.my_comfort<-max([0,1-(temp_int-myself.my_temp_up)/myself.delta_temp_warm]);
			}
		}
		
		//eblouissement et ensoleillement fort en été
		ask window where (each.my_room=my_location) {
			if (!night and temperature>26 and !blind_down) {
				myself.my_comfort<-max([myself.my_comfort-0.2,0.0]);
			}
		}
		
		if (my_comfort<1.0 and activity!=2 and (my_perceive_delta_temp<0 or my_perceive_delta_temp>thermal_effort)) {	
			do add_belief(need_to_discuss_co);
			do add_belief(feel_unconfort);
		}
		else {do remove_belief(feel_unconfort);}
	
//Estimation if he should go to work
		if (work_today and job and current_date.hour >= leave_home_to_job and current_date.hour <= return_home_after_job)	{do add_belief(must_work);	} 
		else	{do remove_belief(must_work);}
		
		
//Estimation if he should go outside
		if (at_home and humidity<80 and temperature>5) {
			if (my_need_of_fresh_air=0)  {
			do add_belief(need_go_out);
			}
			if (my_need_of_fresh_air<0.2){
			do add_belief(need_to_discuss_go);
			}
		}
	
} //End of the perception 1 ---------------------------------------------------------


	perceive target:occupant
	{
		remove all:occupant from:myself.people_to_discuss;
	if (!myself.is_sleeping and myself.at_home) {
		loop myf over:myself.my_family {
			if myf=self {
				if (!self.is_sleeping and self.at_home ) {
					add self to: myself.people_to_discuss;
				}	
			}
		}
		myself.people_to_discuss<-remove_duplicates(myself.people_to_discuss);
	}
	}



//RULES linking belief and desire ---------------------------
	rule belief:is_tired when:sleeping_time new_desire: sleep;
	rule belief:is_hungry when:(breakfast_time or lunch_time or diner_time) new_desire: eat;
	rule belief:must_work new_desire:work;
	rule belief:need_wc new_desire:go_to_wc;
	rule belief:feel_my_cleanliness new_desire: take_a_shower;
	rule belief:feel_unconfort new_desire: mod_temp;	
	rule belief:need_cigarette new_desire:smoke;
	rule belief:need_laundry new_desire:wash_clothes;
	rule belief:need_go_out new_desire:go_out;
	rule belief:need_clean_house new_desire:clean_house;
	rule belief:need_to_discuss_co when:not empty(people_to_discuss) new_desire:discuss_co;
	rule belief:need_to_discuss_go when:not empty(people_to_discuss) new_desire:discuss_go;


reflex prev_loc {
	my_previous_location<-my_location;
	my_previous_activity<-activity;
}

//PLANS that should follow my occupant according to his desire (1 desire for each time step, 1 plan only) ------------------------------------
	plan sleeping intention: sleep	{
		activity<-0;
		P_occ<-74;
		cycle_activity[0]<-cycle_activity[0]+1;
		my_energy <- min([1.0, my_energy + step / h_sleep]);
		location <- any_location_in(my_bedroom.shape_free);
		P_sleep <- 100;
		is_sleeping <- true;
		if (my_energy = 1)	{
			do remove_belief(is_tired);
			do remove_desire(sleep);
			do remove_intention(sleep, false);
			P_sleep <- Def_P_sleep;
			is_sleeping <- false;
		}
	}

	plan relaxing intention: relax	{
		activity<-1;
		P_occ<-106;
		cycle_activity[1]<-cycle_activity[1]+1;
		location <- any_location_in(one_of(room where (each.type = "Sejour")).shape_free);
	}

	plan taking_a_shower intention: take_a_shower	{
		activity<-2;
		P_occ<-211;
		cycle_activity[2]<-cycle_activity[2]+1;
		P_take_a_shower <- 100;
		location <- any_location_in(one_of(room where (each.type = "Salle")).shape_free);
		my_cleanliness <- min([1.0, my_cleanliness + step / h_shower]);
		if my_cleanliness = 1	{
			do remove_belief(feel_my_cleanliness);
			do remove_desire(take_a_shower);
			do remove_intention(take_a_shower, false);
			P_take_a_shower <- Def_P_take_a_shower;
		}

	}

	plan pooping intention: go_to_wc	{
		activity<-3;
		P_occ<-106;
		cycle_activity[3]<-cycle_activity[3]+1;
		P_go_to_wc <- 100;
		location <- any_location_in(one_of(room where (each.type = "WC")).shape_free);
		my_need_to_toilet <- min([1.0, my_need_to_toilet + step / h_poop]);
		if my_need_to_toilet = 1	{
			do remove_belief(need_wc);
			do remove_desire(go_to_wc);
			do remove_intention(go_to_wc, false);
			P_go_to_wc <- Def_P_go_to_wc;
		}
	}


	plan eating intention: eat	{
		if (cook_ok=false) {
			if (self.h_cook>0) {
			do add_subintention(eat,cook, true);
			do current_intention_on_hold();
			}
		} 
		else {
			activity<-4;
			P_occ<-106;
			cycle_activity[4]<-cycle_activity[4]+1;
			P_eat <- 100;
			my_fullness <- min([1.0, my_fullness + step / h_eat]);
			location <- any_location_in(one_of(room where (each.type = "Cuisine")).shape_free);
			if my_fullness = 1		{
				do remove_belief(is_hungry);
				do remove_desire(eat);
				do remove_intention(eat, false);
				P_eat <- Def_P_eat;
				cook_ok<-false;
			}
		}
	}
	
	//sous-intention de manger
	//plan cooking intention:cook  when:h_cook>0 instantaneous: true {
		plan cooking intention:cook  when:h_cook>0  {
		location <- any_location_in(one_of(room where (each.type = "Cuisine")).shape_free);
		activity<-5;
		P_occ<-211;
		cycle_activity[5]<-cycle_activity[5]+1;
		if (cook_ok=true) {
			ask occupant {cook_ok<-true;}
			do remove_intention(cook, true);
			progress<-0.0;
		} 
		else {
			progress<-progress+ step / h_cook;
			if progress>=1 {cook_ok<-true;}
		}
	}
	
	plan working intention: work {
		activity<-6;
		at_home<-false;
		P_occ<-116;
		cycle_activity[6]<-cycle_activity[6]+1;
		my_need_of_fresh_air<-1.0;
		location <- any_location_in(one_of(room where (each.type = "outside")));
		if (current_date.hour >= return_home_after_job)		{
			do remove_belief(must_work);
			do remove_desire(work);
			do remove_intention(work, false);
			my_fullness <- max([0, min([1.0, 1-(current_date.hour - 13) * 0.16])]);
			at_home<-true;
		}
	}
	
	
	plan smoking intention: smoke	{
		activity<-7;
		P_occ<-106;
		cycle_activity[7]<-cycle_activity[7]+1;
		location <- any_location_in(one_of(room where (each.type = "Sejour")).shape_free);
		if Profile=1 or Profile=3 or Profile=4 or Profile=5 or Profile=9 or Profile=10 or Profile=11 or Profile=17 or Profile=18 or Profile=19 or Profile=20 {
		my_need_to_smoke <- min([1, my_need_to_smoke + step / h_smoke]);
		if my_need_to_smoke =1 {
			do remove_belief (need_cigarette);	
			do remove_desire (smoke); 
			do remove_intention(smoke, false);
		}
		
	
			loop w over:window {
			if (w.my_room=my_location) {w.open <-true;}
		}	
			
	
	}else {
		do remove_belief (need_cigarette);	
		do remove_desire (smoke); 
		do remove_intention(smoke, false);
		do add_subintention(smoke,go_out, true);
	}
	
	}
	

	plan washing_clothes intention: wash_clothes	{
		activity<-8;
		P_occ<-150;
		cycle_activity[8]<-cycle_activity[8]+1;
		location <- any_location_in(one_of(room where (each.type = "Salle")).shape_free);	
		ask occupant {
		my_will_to_wash_clothes<-1.0;
		do remove_belief(need_laundry);
		do remove_desire (wash_clothes); 
		do remove_intention(wash_clothes, false);		
		}
			}
	
		
	plan going_out intention:go_out {
		activity <-9;
		cycle_activity[9]<-cycle_activity[9]+1;
		location <- any_location_in(one_of(room where (each.type = "outside")));
		P_go_out <-90;	
		my_need_of_fresh_air <- min ( [1, my_need_of_fresh_air + step/h_take_fresh_air]);
		at_home<-false;
		if smoker {my_need_to_smoke<-1.0;}
		if (my_need_of_fresh_air=1) {
			do remove_belief(need_go_out);
			do remove_desire (go_out); 
			do remove_intention(go_out, false);
			P_go_out <- Def_P_go_out;
			at_home<-true;
			do remove_belief (need_cigarette);	
			do remove_desire (smoke); 
			do remove_intention(smoke, false);
			
		}
	}
	
	
	plan cleaning_house intention:clean_house {
		activity <-10;
		cycle_activity[10]<-cycle_activity[10]+1;
		P_clean_house <-95;
		P_occ<-211;
		location <- any_location_in(one_of(room where (each.type != "outside")));
		house_cleanliness<-min ([1, house_cleanliness + step/h_clean_house]);
		
		if(house_cleanliness=1) {
		ask occupant {
			house_cleanliness<-1.0;
			do remove_belief(need_clean_house);
			do remove_desire (clean_house); 
			do remove_intention(clean_house, false);
			P_clean_house <- Def_P_clean_house;
		}
		}
		
	}
	

	
//Action of communication between the occupants
 plan discuss_my_comfort intention:discuss_co instantaneous:true {	
 		activity <-11;
		cycle_activity[11]<-cycle_activity[11]+1;
 //si je ne suis pas en situation de confort	
 	if my_comfort<1 {			
		bool ac_temp<-true;  //true si tout le monde est d'accord, false si au moins une personne pas d'accord
		ask my_family {
			if self.my_comfort=1 {
				if (myself.social(self)[0]+self.social(myself)[1]-myself.my_comfort)<=1 {ac_temp<-false;	}  //si je n'arrive pas à convaincre quelqu'un
			}				
			else {			//if my_comfort autre<1
				if ((building[0].temp_int>myself.my_temp_up and building[0].temp_int>self.my_temp_up) or (building[0].temp_int<myself.my_temp_low and building[0].temp_int<self.my_temp_low)) {	}
				else {
					if myself.social(self)[0]+self.social(myself)[1]-myself.my_comfort<=1+self.my_comfort+myself.social(self)[1] {ac_temp<-false;}
				}
 			}
 		}	//fin de demande à la famille
		if ac_temp{do add_desire(mod_temp);} //on peut modifier la température que si tout le monde est d'accord	
 	}

		do remove_intention(discuss_co, false);
		do remove_desire(discuss_co);
		do remove_belief(need_to_discuss_co);
 }
	
//Action of communication between the occupants
 plan discuss_going_out intention:discuss_go instantaneous:true {	
		activity <-12;
		cycle_activity[12]<-cycle_activity[12]+1;
//si j'ai envie de prendre l'air 
		if (my_need_of_fresh_air<0.20) {
			bool ac_out <- false;
			ask my_family {
				if (self.my_need_of_fresh_air<0.25) and (myself.social(self)[0]>0.7) and (myself.social(self)[3]+self.social(myself)[1]=1.3) {
					ac_out<-true;					
				}
				if (self.my_need_of_fresh_air>0.25) and (self.my_need_of_fresh_air<0.5) and (myself.social(self)[0]>0.9) and (myself.social(self)[3]+self.social(myself)[1]=1.3) {
					ac_out<-true;						
				}				
			if ac_out{do add_desire(go_out);}
			}			
		}
		do remove_intention(discuss_go, false);
		do remove_desire(discuss_go);
		do remove_belief(need_to_discuss_go);
 }
 

plan modifying_temp intention:mod_temp instantaneous:true {
		activity <-13;
		cycle_activity[13]<-cycle_activity[13]+1;
		
		bool modif_cloth<-false;
		
		//en situation d'inconfort depuis plus que x min, je vais agir d'abord sur mon habillement et sur les fenêtres
		 if current_date>last_temp_modif+delta_date_cloth_modif {  
			
			last_temp_modif<-current_date;			
			window my_window <- one_of(window where(my_room=my_location));
			
			ask building {	
				bool op<-false;	
				if (temp_int<myself.my_temp_low) { //If I am cold
					ask window { // I close any open window of the house
						if (open) {
							op<-true;
							open <- false;
						}
					}
					if ( !myself.sweater) { //than I put on a sweater if I am not wearing one
						myself.clothing <- myself.clothing + 0.25;
						myself.sweater<-true;
						modif_cloth<-true;
						}
					}
					
				if (temp_int>myself.my_temp_up) {  //If I am warm
					if (rad_on=true) {rad_on<-false;}  // I turn off the heating devices
					ask window { //I open all the windows in my room
						if (my_window!=nil) {
							if (my_window.open=false) {
								my_window.open<-true;
								op<-false;
							}
						}	
					}
					if 	myself.sweater { // I put off my sweater if I am wearing one
						myself.clothing <- myself.clothing - 0.25;
						myself.sweater<-false;
						modif_cloth<-true;
					}			
				}
			}
		}
						
		
		if (current_date>last_temp_modif_clo+delta_date_temp_modif){   
			last_temp_modif_clo<-current_date;
			
			ask building {	
				if (temp_int<myself.my_temp_low) { //If I am cold
					if (rad_on=false) {rad_on<-true;} //j'allume le chauffage si j'ai froid
					
					if type_regul=0 {			//si manuel, j'ajuste moi meme le thermostat
							thermostat <- (1- myself.my_comfort);
							regul_manual<-true;
						}  
					if (type_regul=2) {		//si automatique, je laisse faire la regulation
							regul_manual<-false;
							temp_regul<-myself.ideal_temp;
					} 
					if (type_regul=1) {		//si mixte
								if current_date.hour>21 and current_date.hour<7{
									regul_manual<-false;
									temp_regul<-myself.ideal_temp-myself.delta_temp_cold/2;
								}	
								else {
									if (myself.job and working_day and current_date.hour<19 and current_date.hour>8) {
										regul_manual<-false;
						
										temp_regul<-myself.ideal_temp-myself.delta_temp_cold/2;
									}
									else {
										thermostat <- (1- myself.my_comfort);
										regul_manual<-true;
									}
								}
					}				
				}
				
				if (temp_int>myself.my_temp_up) {  //If I am warm
					if type_regul=0 and thermostat>0{			//si manuel, j'ajuste moi meme le thermostat
							thermostat <- 0.0;
							regul_manual<-true;
						}  
					//write "I want a ventilateur";
				}
			}					
		}

		do remove_intention(mod_temp, false);
		do remove_desire(mod_temp);
		do remove_belief(feel_unconfort);

}	//fin de ensure my_comfort
// End of the plans  



//Aspect -------------------------------------
	aspect default	{
		draw obj_file(my_file,init_rotation) at: location + {0,0,0.2 + mysize/2.0} size: {2,2,mysize}  ;
		draw name at: location + {0,0, 2.0} color: #black font: font("Helvetica", 18 * #zoom, #bold);
	}
}
//**************************************END OF THE AGENT OCCUPANT **********************************


